#include "Boss3.h"

Boss3::Boss3(Player * p, ALLEGRO_BITMAP * image, int x_, int y_, int Pos) {
	position = Pos;// del 0 - 7 para la imagen scout.png (vease la imagen)
	prota = p;
	move = true;// movimiento en general
	moveX = false;//en eje x
	moveY = false;//en eje y
	name = "Meatless";
	cont = 1;
	info = al_load_bitmap("imagenes/objetos/text_box.png");
	font = al_load_ttf_font("fuentes/arial.ttf", 25, 0);
	x = x_;
	y = y_;
	Init(image);
}

void Boss3::Init(ALLEGRO_BITMAP * image) {
	SetID(ENEMY);
	SetAlive(true);
	life = 50;
	GameObject::Init(x, y, 1, 1, 0, 0, 76, 93);
	al_convert_mask_to_alpha(image, al_map_rgb(255, 255, 255));
	say = al_load_sample("sonidos/got.ogg");
	lf = new Wall(625, 15, al_load_bitmap("imagenes/Sprites/life_skull.png"), prota, 1);
	dead = new Wall(110, 225, al_load_bitmap("imagenes/Objetos/tumba.png"), prota, Wall::TOMB);
	key3 = new Key(320, 225, al_load_bitmap("imagenes/Items/key3.png"),3);
	if (prota->k3)
		SetAlive(false);
	curFrame = 0;
	frameWidth = 152;
	frameHeight = 186;
	animationColumns = 1;
	animationRow = 1;
	if (image != NULL)
		this->image = image;
}

void Boss3::Update() {
	if (this->GetAlive()) {
		GameObject::Update();
		for (iter = spawn.begin(); iter != spawn.end();) {
			(*iter)->Update();
			if (!(*iter)->GetAlive()) {
				(*iter)->Destroy();
				delete(*iter);
				iter = spawn.erase(iter);
			}
			else { iter++; }
		}

		if (x < 75) {
			SetX(75);
			moveX = !moveX;
		}
		else if (x > 565) {
			SetX(565);
			moveX = !moveX;
		}

		if (y < 95) {
			SetY(95);
			moveY = !moveY;
		}
		else if (y > 360) {
			SetY(360);
			moveY = !moveY;
		}
		if (life <= 0) {
			SetAlive(false);
		}

		if (cont % 500 == 0 || cont == 100) {
			Enemy *rat0 = new Enemy(prota, al_load_bitmap("imagenes/Sprites/rat.png"), this->GetX() - 30, this->GetY(), 0, 0);
			Bullet *bullet0 = new Bullet(this->GetX(), this->GetY(), 1);
			Bullet *bullet1 = new Bullet(this->GetX(), this->GetY(), 2);
			spawn.push_back(rat0);
			spawn.push_back(bullet0);
			spawn.push_back(bullet1);
		}
		if (prota->GetY() < this->GetY())
			MoveUp();
		if (prota->GetY() > this->GetY())
			MoveDown();
		if (prota->GetX() < this->GetX())
			MoveLeft();
		if (prota->GetX() > this->GetX())
			MoveRight();
		cont++;
	}
	else {
		dead->Update();
		if (!prota->k3) {
			if (prota->CheckCollisions(key3)) {
				key3->Collided(prota->GetID());
				prota->Collided(key3->GetID());
				prota->k3 = true;
			}
		}
	}
}

void Boss3::Render() {
	if (this->GetAlive()) {
		int fx = 0;
		int fy = 0;
		al_draw_bitmap_region(image, fx, fy, frameWidth, frameHeight,
			x - frameWidth / 2, y - frameHeight / 2, 0);

		lf->Render();//<-- life image

		for (iter = spawn.begin(); iter != spawn.end(); iter++)
			(*iter)->Render();

		al_draw_textf(font, al_map_rgb(62, 4, 61), 580, 5, ALLEGRO_ALIGN_CENTRE, "*%i*", this->getLife());
	}
	else {
		SetX(110);
		SetY(225);
		dead->Render();
		if (!prota->k3)
			key3->Render();

	}
}

void Boss3::Collided(int objectID) {
	if (objectID == BULLET) {
		life--;
	}
}

void Boss3::Destroy() {
	Enemy::Destroy();
	delete(dead);
	delete(lf);
	delete(key3);
}

