#pragma once

#include "NPC.h"
#include "Wall.h"
#include "Key.h"
#include <allegro5/allegro_audio.h>
#include <allegro5/allegro_ttf.h>

/*! @brief Clase Enemy.
*			Crea objetos hostiles para "Player".
*
*
* Objeto Enemy hereda atributos de NPC y causa daos en colision con
* el "Player"
*/
class Enemy : public NPC {
protected:
	int life;/**< Entero, vida del objeto. */
public:
	Enemy();
	Enemy(Player *p, ALLEGRO_BITMAP *image, int x_, int y_, int Posicion, int Type);
	void Init(ALLEGRO_BITMAP *image = NULL);
	void Update();
	void Render();
	int getLife() { return life; }
	void destroy_ammo();
	void MoveUp();
	void MoveDown();
	void MoveLeft();
	void MoveRight();
	void Collided(int objectID);
	void Destroy();
	std::list<GameObject *> spawn;
	std::list<GameObject *>::iterator iter;
};