#include "GameObject.h"

GameObject::GameObject(){
	x = 0;
	y = 0;
	
	velX = 0;
	velY = 0;

	dirX = 0;
	dirY = 0;

	boundX = 0;
	boundY = 0;

	curFrame = 0;
	frameWidth = 0;
	frameHeight = 0;
	animationColumns = 0;

	image = NULL;

	alive = true;
	collidable = true;
}
/*! @brief Metodo Destroy.
*			Destructor.
*
* Destruye todos los punteros que tenga el objeto.
*/
void GameObject::Destroy(){}
/*! @brief Metodo Init.
*			Inicializa.
*
* Inicializa las variables del abjeto.
*/
void GameObject::Init(float x, float y, float velX, float velY, int dirX, int dirY, int boundX, int boundY){
	GameObject::x = x;
	GameObject::y = y;

	GameObject::velX = velX;
	GameObject::velY = velY;

	GameObject::dirX = dirX;
	GameObject::dirY = dirY;

	GameObject::boundX = boundX;
	GameObject::boundY = boundY;
}
/*! @brief Metodo Update.
*			Actualiza el objeto.
*
* Cambia valor de algunos atributos, contiene ciertas restricciones.
*/
void GameObject::Update(){
	x += velX * dirX;
	y += velY * dirY;
}
/*! @brief Metodo CheckCollisions.
*			Chequea colisiones.
*
* Revisa posicines y dimensiones para comprobar colisin entre objetos.
*/
bool GameObject::CheckCollisions(GameObject *otherObject){
	int oX = otherObject->GetX();
	int oY = otherObject->GetY();

	int obX = otherObject->GetBoundX();
	int obY = otherObject->GetBoundY();

	if( x + boundX > oX - obX &&
		x - boundX < oX + obX &&
		y + boundY > oY - obY &&
		y - boundY < oY + obY)
		return true;
	else
		return false;
}
/*! @brief Metodo Collided.
*			Con qu colisiona?.
*
* Reacciona de multiples formas dependiendo del objeto con el que choc.
*/
void GameObject::Collided(int objectID){}
/*! @brief Metodo Collidable.
*			Puedo colisionar?.
*
* Verifica si el objeto es colisionable o si an sigue vivo.
*/
bool GameObject::Collidable(){
	return alive && collidable;
}
