#include "Room3.h"

Room3::Room3(ALLEGRO_BITMAP *image, Player *p, int Type) :Room(image, p, velX) {
	prota = p;
	type = Type;
	has_enemy = false;
	left = new Door(20, 230, al_load_bitmap("imagenes/Objetos/door1_volt.png"), true);
	if (type == 0) {
		npc0 = new NPC(prota, al_load_bitmap("imagenes/Sprites/scout.png"), 200, 100, 5, 0, NULL);
		block0 = new Wall(325, 230, al_load_bitmap("imagenes/Objetos/tree.png"), prota, Wall::ARBOL);
		spawn.push_back(npc0);
		spawn.push_back(block0);
	}
	if (type == 1) {
		has_enemy = true;
		boss1 = new Boss1(prota, al_load_bitmap("imagenes/Sprites/Grue.png"), 530, 225, 0);
		block0 = new Wall(40, 235, al_load_bitmap("imagenes/Objetos/reja1_v.png"), prota, Wall::REJA_V);
	}
	if (type == 2) {
		has_enemy = true;
		boss2 = new Boss2(prota, al_load_bitmap("imagenes/Sprites/guaren.png"), 530, 225, 0);
		block0 = new Wall(40, 235, al_load_bitmap("imagenes/Objetos/reja1_v.png"), prota, Wall::REJA_V);
		block1 = new Wall(325, 230, al_load_bitmap("imagenes/Objetos/tree_lsd.png"), prota, Wall::ARBOL);
		spawn.push_back(block1);
	}
}
//260 -375
void Room3::boundary(int num) {
	if (prota->GetY() < 95 && num == 0) {
		prota->SetY(95);
	}
	else if (prota->GetY() > 360 && num == 1) {
		prota->SetY(360);
	}
	else if (prota->GetX() < 75 && num == 2) {
		if (prota->GetY() > 180 && prota->GetY() < 270) {}
		else { prota->SetX(75); }
	}
	else if (prota->GetX() > 565 && num == 3) {
		prota->SetX(565);
	}
	else if (prota->GetX() < 75) {
		if (prota->GetY() < 180 + CACHO && prota->GetY() > 160 && num == 0) { prota->SetY(180 + CACHO); }
		else if (prota->GetY() > 270 - CACHO && prota->GetY() < 280 && num == 1) { prota->SetY(270 - CACHO); }
	}
	if (type == 0) {
		if (npc0->CheckCollisions(prota)) {
			npc0->boundary(num);
		}
		if (block0->CheckCollisions(prota)) {
			block0->boundary(prota);
		}
	}
	if (type == 1) {
		if (boss1->CheckCollisions(prota)) {
			boss1->getTomb()->boundary(prota);
		}
		if (block0->CheckCollisions(prota) && !block0->getOpen()) {
			block0->boundary(prota);
			if (prota->k1)
				block0->setOpen(true);
		}
	}
	if (type == 2) {
		for (iter = boss2->spawn.begin(); iter != boss2->spawn.end(); iter++) {
			if ((*iter)->CheckCollisions(block0)) {
				block1->boundary(*iter);
			}
		}
		if (boss2->CheckCollisions(prota)) {
			boss2->getTomb()->boundary(prota);
		}
		if (block0->CheckCollisions(prota) && !block0->getOpen()) {
			block0->boundary(prota);
			if (prota->k2)
				block0->setOpen(true);
		}
		if (block1->CheckCollisions(prota)) {
			block1->boundary(prota);
		}
	}
}

void Room3::Render() {
	al_draw_bitmap(image, x, y, 0);
	if (type == 1) {
		boss1->Render();
		if (!block0->getOpen())
			block0->Render();
	}
	if (type == 2) {
		boss2->Render();
		if (!block0->getOpen())
			block0->Render();
	}
	for (iter = spawn.begin(); iter != spawn.end(); iter++)
		(*iter)->Render();
}
void Room3::Update() {
	for (iter = spawn.begin(); iter != spawn.end();) {
		(*iter)->Update();
		if (!(*iter)->GetAlive()) {
			(*iter)->Destroy();
			delete(*iter);
			iter = spawn.erase(iter);
		}
		else { iter++; }
	}
	if (type == 0) {
		if (prota->CheckCollisions(left)) {
			prota->Collided(left->GetID());
			prota->setRoom(1);
			prota->setSet(2);
		}
		if (npc0->CheckCollisions(prota)) {
			npc0->Collided(prota->GetID());
		}
	}
	if (type == 1) {
		boss1->Update();
		if (boss1->GetAlive()) {
			list_Collided(prota->ammo, boss1);
			list_Collided(boss1->spawn, prota);
			if (prota->CheckCollisions(boss1) && getCont() % 5 == 0) {
				prota->Collided(boss1->GetID());
			}
			Active_Cont();
		}

		if (prota->CheckCollisions(left)) {
			prota->Collided(left->GetID());
			prota->setRoom(1);
			prota->setSet(2);
			prota->setType_Room(0);
		}
		if (prota->getLife() <= 0) {
			prota->setRoom(1);
			prota->setSet(2);
			prota->setType_Room(0);
		}
	}
	else if (type == 2) {
		list_to_list(spawn, prota->ammo);
		boss2->Update();
		if (boss2->GetAlive()) {
			list_Collided(prota->ammo, boss2);
			list_to_list(prota->ammo, boss2->spawn);
			list_Collided(boss2->spawn, prota);
			if (prota->CheckCollisions(boss2) && getCont() % 5 == 0) {
				prota->Collided(boss2->GetID());
			}
			Active_Cont();
		}

		if (prota->CheckCollisions(left)) {
			prota->Collided(left->GetID());
			prota->setRoom(6);
			prota->setSet(2);
			prota->setType_Room(0);
		}
		if (prota->getLife() <= 0) {
			prota->setRoom(6);
			prota->setSet(2);
			prota->setType_Room(0);
		}
	}
}

void Room3::Destroy() {
	delete(left);
	for (iter = spawn.begin(); iter != spawn.end(); iter++) {
			(*iter)->Destroy();
			delete(*iter);
	}
	if (type == 1) {
		boss1->Destroy();
		delete(boss1);
		delete(block0);
	}
	if (type == 2) {
		boss2->Destroy();
		delete(boss2);
		delete(block0);
	}
}
